---
home: true
heroText: Anchor
tagline: A framework for building Solana programs
actionText: Get Started →
actionLink: /getting-started/introduction
features:
- title: Security
  details: Anchor eliminates many footguns of raw Solana programs by default and allows you to add more security checks without disrupting your business logic.
- title: Code Generation
  details: (De)Serialization, cross-program invocations, account initialization, and more.
- title: IDL & Client Generation
  details: Anchor generates an IDL based on your program and automatically creates a typescript client with it.
- title: Verifiability
  details: Anchor programs can be built verifiably, so users know that the on-chain program matches the code base.
- title: Workspace Management
  details: The CLI helps you manage workspaces with multiple programs, e2e tests, and more.
- title: Compatibility
  details: Anchor programs can interact with all non-anchor programs on Solana.

footer: Apache License 2.0
---
<div style="border: 2px solid red; text-align: center; padding: 10px 10px 10px 10px; box-sizing: border-box"> This documentation is being sunset in favor of <a href="https://book.anchor-lang.com" rel="noopener noreferrer" target="_blank">The Anchor Book</a>. At this point in time, either documentation may contain information that the other does not.</div>
